# include	<CStaggeredWindowArranger.h>

CStaggeredWindowArranger::CStaggeredWindowArranger(
	const BPoint& inOrigin, const BPoint& inFrameSize,
	const BPoint& inOffset, int inMaxWindowsBeforeRepeat )

:	mOriginalRect( inOrigin, inOrigin + inFrameSize ),
	mOffset( inOffset ),
	mMaxWindowsBeforeRepeat( inMaxWindowsBeforeRepeat )
{
	mCurrentWindowCount = 0;
}

BRect CStaggeredWindowArranger::NextFrame( )
{
	BRect frame = mOriginalRect;
	int dx, dy;
	
		// Build rectangle
	dx = mOffset.x * mCurrentWindowCount;
	dy = mOffset.y * mCurrentWindowCount;
	frame.OffsetBy( dx, dy );
	
		// Update current window counter 
	mCurrentWindowCount++;
	mCurrentWindowCount %= mMaxWindowsBeforeRepeat;
	
	return frame;
}