# pragma	once
# ifndef	_IC_API_H
# define	_IC_API_H

# ifndef	_IC_TYPES_H
# include	"ICTypes.h"
# endif


//=========================================================================
//	* ICAPI.h
//=========================================================================
//	This file contains an early prototype of the Internet Config interface.
//	Eventually, this will be moved into a server, but for now, it's
//	easier to link with each application individually.

class ICInstance
{
public:
					ICInstance(
						long			inCreatorCode );
					~ICInstance( );

	ICError			DisplayURL( 
						const char*		inURL,
						int				inFlags
								= IC_SMART_HELPERS | IC_HANDLE_ERRORS ) const;
	void			RegisterURLSchemes(
						const char**	inSchemeList );

	
		// XXX - The following will be replaced. Don't use them.

	long			GetPref(
						const char*		inKey,
						ICAttr*			outAttr,
						void*			outPrefData,
						long*			ioPrefDataSize ) const;
	long			GetPrefMalloc(
						const char*		inKey,
						ICAttr*			outAttr,
						void**			outNewPrefData,
						long*			outPrefDataSize ) const;
	long			SetPref(
						const char*		inKey,
						ICAttr			inAttr,
						void*			inPrefData,
						long			inPrefDataSize );
						
private:
	long			mCreatorCode;

	ICError			InitDatabaseTables( );
	ICError			GetPrefRecord( const char* inKey );
};

# endif