# include	<OS.h>
# include	<string.h>

# include	<CGrowBlock.h>
# include	<ErrorUtilities.h>

CGrowBlock::CGrowBlock( const char* inName )
{
	mLogicalSize = 0;
	mPhysicalSize = B_PAGE_SIZE;
	
	mAddress = NULL;
	mArea = create_area( inName, &mAddress, B_ANY_ADDRESS,
		mPhysicalSize, B_NO_LOCK, B_READ_AREA | B_WRITE_AREA );
		
	if ( mArea < B_NO_ERROR )
		ReportFatalError( mArea, "Couldn't allocate area." );
}	
	
CGrowBlock::~CGrowBlock( )
{
	delete_area( mArea );
}
	
void CGrowBlock::SetSize( long inSize )
{
	mLogicalSize			= inSize;
	long newPhysicalSize	= inSize;
	
		// pad it to equal a page boundry
	newPhysicalSize += B_PAGE_SIZE - ( mLogicalSize % B_PAGE_SIZE );

	if ( mPhysicalSize != newPhysicalSize )
	{
		if ( resize_area( mArea, newPhysicalSize ) != B_NO_ERROR )
		{
				// XXX - Gross hack: allocate new area
			area_id	oldArea = mArea;
			void*	oldAddress = mAddress;
			mAddress = NULL;
			mArea = create_area( "XXX/GrowBuffer", &mAddress, B_ANY_ADDRESS,
				newPhysicalSize, B_NO_LOCK, B_READ_AREA | B_WRITE_AREA );
			if ( mArea < B_NO_ERROR )
				ReportFatalError( mArea, "Couldn't reallocate area." );
			memcpy( mAddress, oldAddress, mPhysicalSize );
			delete_area( oldArea );
		}
				
		mPhysicalSize = newPhysicalSize;
	}
}

void CGrowBlock::Append( const void* inData, long inSize )
{
	if ( inSize )
	{
			// XXX - Be aware of possible relocation
		long oldSize = mLogicalSize;
		SetSize( mLogicalSize + inSize );
		memcpy( (char*) mAddress + oldSize, inData, inSize );
	}
}
