# include	<stdio.h>
# include	<errno.h>
# include	<ErrorUtilities.h>


//=========================================================================
//	* _InternalReportError
//=========================================================================

# ifndef	__BEOS_GUI__

void _InternalReportError( ErrorCode inErr, const char* inFileName,
	int inLineNumber, const char* inReason, int inCategory )
{
	if ( inErr == genericUnixErr )
	{
		fprintf( stderr, "Unix error %d in %s line %d: %s\n",
			errno, inFileName, inLineNumber, inReason );
	}
	else
	{
		fprintf( stderr, "Internal error %d in %s line %d: %s\n",
			inErr, inFileName, inLineNumber, inReason );
	}

	if ( inCategory == kFatalErr )
		exit( inErr );
}

# else

void _InternalReportError( ErrorCode inErr, const char* inFileName,
	int inLineNumber, const char* inReason, int inCategory )
{
	char errbuff[2048];

	if ( inErr != genericUnixErr )
	{
		sprintf( errbuff, "%s\n\nFile: %s\nLine: %d\nError: %d",
			inReason, inFileName, inLineNumber, inErr ); 
	}
	else
	{
		sprintf( errbuff, "%s\n\nFile: %s\nLine: %d\nUnix error: %d",
			inReason, inFileName, inLineNumber, errno ); 
	}
	
	BAlert* alert = new BAlert( "", errbuff, "OK", NULL, NULL,
		B_WIDTH_AS_USUAL, B_STOP_ALERT );
	alert->Go( );
	
	if ( inCategory == kFatalErr )
		/* XXX - Fatal errors not supported */;
}

# endif
