# ifndef __SOCKETUTILITIES__
# define __SOCKETUTILITIES__

# ifndef __ERRORUTILITIES__
# include "ErrorUtilities.h"
# endif

# define	MAXLINE			(1024)


//=========================================================================
//	* Error codes
//=========================================================================

enum {
	noResponseCodeFoundErr = 100,
	endOfTextBlockErr,
	nntpProtocolErr
};


//=========================================================================
//	* Function Prototypes
//=========================================================================

# ifdef __cplusplus
extern "C" {
# endif

extern ErrorCode ReadLineFromSocket( int inSocket, char** outLinePtr );
extern ErrorCode WriteLineToSocket( int inSocket, const char* inLineBuffer );
extern ErrorCode ReadFinalResponseLine( int inSocket, char** outLinePtr );
extern ErrorCode ExtractResponseCode( const char* inServerText, int* outResponseCode );
extern int IsNNTPErrorCode( int inResponseCode );
extern ErrorCode ReadTextLine( int inSocket, char** outLinePtr );
extern ErrorCode SendNNTPCommand( int inSocket, const char* inCommandPtr );

# ifdef __cplusplus
};
# endif

# endif