# include	<stringclass.h>
# include	<ErrorUtilities.h>

	// XXX - Code duplication with InstallString
string::string( const char* inText, long inLength )
{
	mString = new char[inLength + 1];
	if ( mString == NULL )
		ReportFatalError( genericUnixErr, "couldn't allocate string memory" );
	memcpy( mString, inText, inLength );
	mString[inLength] = '\0';
}	

string& string::operator=( const string& inRight )
{
	if ( &inRight != this )
	{
		delete [] mString;
		InstallString( inRight.mString );
	}
	return *this;
}

void string::InstallString( const char* inString )
{
	mString = new char[strlen(inString) + 1];
	if ( mString == NULL )
		ReportFatalError( genericUnixErr, "couldn't allocate string memory" );
	strcpy( mString, inString );
}

string& string::operator+=( const string& inRight )
{
	char* temp;
	temp = new char[length( ) + inRight.length( ) + 1];
	if ( mString == NULL )
		ReportFatalError( genericUnixErr, "couldn't allocate string memory" );
	strcpy( temp, mString );
	strcat( temp, inRight );
	delete [] mString;
	mString = temp;
	return *this;
}

string string::substring( int inStart, int inLength ) const
{
		// Allocate a new string object without data
	string result;
	delete [] result.mString;
	
		// Allocate it the appropriate size chunk of data
	result.mString = new char[inLength + 1];
	if ( result.mString == NULL )
		ReportFatalError( genericUnixErr, "couldn't allocate string memory" );

		// Copy the substring into the new string
	strncpy( result.mString, &(mString[inStart]), inLength );
	result.mString[inLength] = '\0';

	return result;
}

int string::findchar( char inChar ) const
{
	int i, len = length( );
	for ( i = 0; i < len; i++ )
		if ( mString[i] == inChar )
			break;
	return (i == len) ? -1 : i;
}

string string::tailstring( int inStart ) const
{
	return substring( inStart, length( ) - inStart );
}

void string::truncate( int inLength )
{
	if ( length( ) <= inLength )
		return;

		// XXX - Should we reclaim memory?	
	mString[inLength] = '\0';
}
	
char* strnstr( const char* inString, const char* inPattern,
	int inLength )
{
		// XXX - Empty patterns match immediately. Good idea?
	if ( inPattern[0] == '\0' )
		return (char*) inString;
	
	int patlen = strlen( inPattern );
	for ( int i = 0; i < (inLength - patlen) + 1 && inString[i] != '\0'; i++ )
	{
		if ( inString[i] == inPattern[0] )
		{
			int j;
			for ( j = 0; j < patlen && inString[i+j] != '\0'; j++ )
				if ( inString[i+j] != inPattern[j] )
					break;
			
			if ( j == patlen )
				return (char*) &inString[i];
		}
	}	

	return NULL;
}
