# ifndef __STRINGCLASS__
# define __STRINGCLASS__

# include <string.h>

# ifndef __BEOS_GUI__
# include <iostream.h>
# endif

char* strnstr( const char* inString, const char* inPattern, int inLength );

class string
{
private:
	char* mString;

	void InstallString( const char* inString );
	
public:	
	string( const char* inString = "" );
	string( const char* inText, long inLength );
	string( const string& inString );
	~string( );
	
	char& operator[]( const int i ) { return mString[i]; }
	const char& operator[]( const int i ) const { return mString[i]; }
	
	string& operator=( const string& inRight );
	string& operator+=( const string& inRight );
	
	operator char*( ) { return mString; }
	operator const char*( ) const { return mString; }
	
	int length( ) const { return strlen( mString ); }
	string substring( int inStart, int inLength ) const;
	int findchar( char inChar ) const;
	string tailstring( int inStart ) const;
	
	void truncate( int inLength );

# ifndef __BEOS_GUI__
	friend ostream& operator<<( ostream& o, const string& s );
# endif
};

inline string::string( const char* inString )
{
	InstallString( inString );
}

inline string::string( const string& inString )
{
	InstallString( inString.mString );
}

inline string::~string( )
{
	delete [] mString;
}

inline bool operator==( const string& inLeft, const string& inRight )
{
	return ( strcmp( inLeft, inRight ) == 0 );
}

inline bool operator<( const string& inLeft, const string& inRight )
{
	return ( strcmp( inLeft, inRight ) < 0 );
}

inline bool operator!=( const string& inLeft, const string& inRight )
{
	return !(inLeft == inRight);
}

inline bool operator>( const string& inLeft, const string& inRight )
{
	return inRight < inLeft;
}

inline bool operator<=( const string& inLeft, const string& inRight )
{
	return !(inRight < inLeft);
}

inline bool operator>=( const string& inLeft, const string& inRight )
{
	return !(inLeft < inRight);
}

inline string operator+( const string inLeft, const string& inRight )
{
	string temp = inLeft;
	temp += inRight;
	return temp;
}

# ifndef __BEOS_GUI__
inline ostream& operator<<( ostream& o, const string& s )
{
	return o << s.mString;
}
#endif

#endif