# include	<CStream.h>
# include	<ErrorUtilities.h>
# include	<stringclass.h>
# include	<CGrowBlock.h>

	// XXX - be sure to test with a smaller buffer size
# define	BUFFER_SIZE (512)

CStream::CStream( const char* inName )
{
	mError = B_NO_ERROR;

	strncpy( mName, inName, B_OS_NAME_LENGTH );

	string blockName = "gb>";
	blockName += mName;
	blockName.truncate( B_OS_NAME_LENGTH );
	
	mBuffer = new CGrowBlock( blockName ); 
	if ( !mBuffer )
	{
		/* ERROR */;
		mError = B_ERROR;
	}	
}

CStream::~CStream( )
{
	delete mBuffer;
}

long CStream::ReadLine( string& outLine )
{
	char buff[BUFFER_SIZE];

		// XXX - dependent on "\r\n" as a delimiter
	while ( 1 )
	{
			// XXX - Don't re-search from beginning
		char* eol = strnstr( (char*) mBuffer->Data( ), "\r\n",
			mBuffer->DataSize( ) );

//		char* end = &((char*)mBuffer->Data( ))[mBuffer->DataSize( )];
//		printf( "%d %d\n", int(*(end - 1)), int(*end) );

			// Take a line from the buffer and return if we can
		if ( eol )
		{
				// XXX - Move some of this into CGrowBlock
			long lineSize = eol - mBuffer->Data( );
			long newSize = mBuffer->DataSize( ) - (lineSize + 2);
			outLine = string( (char*) mBuffer->Data( ), lineSize );
			memmove( mBuffer->Data( ), eol + 2, newSize );
			mBuffer->SetSize( newSize );
			return B_NO_ERROR;
		}
	
		int count = Read( buff, BUFFER_SIZE );
		
		if ( count <= 0 )
		{
				// Deal with dropped connections & errors
				// XXX - Read should never return 0. We treat it as
				// ENOTCONN, a closed connection.
				// XXX - Should we return data and errors together? Probably not.
			outLine = string( (char*) mBuffer->Data( ), mBuffer->DataSize( ) );
			mBuffer->SetSize( 0 );
			mError = count ? count : ENOTCONN;
			return mError;
		}
		else
		{
				// Buffer the data we just read
			mBuffer->Append( buff, count );
		}
	}
	
		// XXX - Never executed
	return 0;
}
	
long CStream::WriteLine( const string& inLine )
{
	return Write( inLine + "\r\n", strlen( inLine ) + 2 );
}