# pragma	once
# ifndef	__STREAMCLASS__
# define	__STREAMCLASS__

# include	<stringclass.h>

class CGrowBlock;

class CStream
{
private:
	char		mName[B_OS_NAME_LENGTH];
	CGrowBlock*	mBuffer;

protected:
	long		mError;
		
public:
	enum /* State */ {
		OpenState = 0,
		ClosedState
	};
	
					CStream( const char* inName );
	virtual			~CStream( );
	
	virtual	long	Read(
						void* outBuffer, 
						long inBufferSize ) = 0;
	virtual long	Write( 
						const void* inBuffer,
						long inBufferSize ) = 0;

	virtual	long	ReadLine( string& outLine );
	virtual long	WriteLine( const string& inLine );
	
	virtual void	Close( ) = 0;
	virtual long	State( ) const = 0;

	long			Error( ) { return mError; }	
};

# endif
