# pragma	once
# ifndef	__TCPSTREAMCLASS__
# define	__TCPSTREAMCLASS__

# include	<CStream.h>

enum /* Special interfaces */ {
	LOOPBACK_INTERFACE	= 0x7F000001,	// Handled by net_server
	PRIMARY_INTERFACE	= 0x00000000	// Converted interally
};

class CTCPStream : public CStream
{
protected:
	int		mSocket;
	bool	mIsOpen;

	static BLocker sTCPLock;
	static struct hostent* sLocalHost;
	static ulong sLocalIP;

					CTCPStream( const char* inName, int inSocket );
	static bool		IsLocalIP( ulong inIP );
	static void		CacheLocalHost( );

public:
					CTCPStream( const char* inName );
					CTCPStream( int inSocket );
					~CTCPStream( );
					
	virtual	long	Read(
						void* outBuffer, 
						long inBufferSize );
	virtual long	Write( 
						const void* inBuffer,
						long inBufferSize );

	virtual void	Close( );
	virtual long	State( ) const;

	virtual long	Connect( const char* inHostname, int inPort );
	virtual long	Bind( ulong inInterface, int inPort );
	virtual long	Listen( int inBacklog );
	virtual CTCPStream*	Accept( );
};

# endif