# pragma once
# ifndef __STPTR__
# define __STPTR__

template <class T>
class StBind
{
private:
	T*	mPtr;
	
					StBind( StBind& )
						{ /* UNIMP */ }
	StBind&			operator=( StBind& s )
						{ return s; /* UNIMP */ }

public:
					StBind( T* inPtr = NULL );
					~StBind( );
	
	T*				operator->( ) { return mPtr; }		
	const T*		operator->( ) const { return mPtr; }

	T&				operator*( ) { return *mPtr; }		
	const T&		operator*( ) const { return *mPtr; }

	T*				operator T*( ) { return mPtr; }		
	const T*		operator T*( ) const { return mPtr; }

	StBind&			operator=( T* );

	void			delete_obj( ) { delete mPtr; mPtr = NULL; }
	T*				release( ) { T* p = mPtr; mPtr = NULL; return p; }

	T*				ptr( ) { return mPtr; }
	const T*		ptr( ) const { return mPtr; }
};

template <class T>
StBind<T>::StBind( T* inPtr )
{
	if ( inPtr == NULL )
		/* ERROR */;
	mPtr = inPtr;
}

template <class T> inline
StBind<T>::~StBind( )
{
	if ( mPtr )
		delete mPtr;
}

template <class T>
StBind<T>& StBind<T>::operator=( T* inPtr )
{
	if ( inPtr == NULL )
		/* ERROR */;
	if ( mPtr )
		delete mPtr;
	mPtr = inPtr;
	return *this;
}

# endif
