# pragma	once
# ifndef	__CTHREAD__
# define	__CTHREAD__

//=== System headers

# ifndef	_OS_H
# include	<OS.h>
# endif

//=== Library headers

# ifndef	__STRINGCLASS__
# include	<stringclass.h>
# endif

# define	C_THREAD_FINISHED	(0) /* New thread state */

class CThread
{
private:
	bool			mIsThreadFinished;
	thread_id		mThreadID;
	BLocker			mDeathLock;
	
	static long 	EnterThreadCallback( void* inThreadObject );
	void 			EnterThread( );
	
protected:
	virtual void	RunThread( )		= 0;
	virtual void	ThreadFinished( )	{ }

public:
					CThread( const char* inName, long inPriority );
					~CThread( );

	thread_id		ID( ) { return mThreadID; }
	void			Info( thread_info& outThreadInfo );
	string			Name( );
	long			Priority( );
	long			State( sem_id* outBlockingSemaphore = NULL );

	virtual void	SetName( const char* inName );
	virtual void	SetPriority( long inPriority );

	virtual void	Suspend( );
	virtual void	Resume( );
	virtual void	Kill( );
	virtual void	WaitFor( );
};

# endif